/*
 * Created by Stefan Korecko, 2016-20
 */


//SK texts:
let txtInitFrms ="Inicializujem formuláre.";
let txtWriteAlert = "Nemám kam zapísať."
let txtHds =" nadpisy";
let txtNoRemove="Nie je čo odstraňovať.";
let txtEvent ="Udalosť ";
let txtOn = " na ";
let txtRecFor = " zaznamenané pre ";
let colors=[["Červené","red"],["Zelené","green"],["Modré","blue"]]; //2nd value is css color name

//EN texts:

/*
const txtInitFrms ="Initializing forms.";
const txtWriteAlert = "Nowhere to write."
const txtHds =" headings";
const txtNoRemove="Nothing to remove.";
const txtEvent ="Event ";
const txtOn = " on ";
const txtRecFor = " recorded for ";
const colors=[["Red","red"],["Green","green"],["Blue","blue"]]; //2nd value is css color name
*/

//Other vars:
let colIdx=0;
let nextArtIndex=1;

//Functions:

function formInit(language) {

    if(language=='en'){
        //EN texts:
        txtInitFrms ="Initializing forms.";
        txtWriteAlert = "Nowhere to write."
        txtHds =" headings";
        txtNoRemove="Nothing to remove.";
        txtEvent ="Event ";
        txtOn = " on ";
        txtRecFor = " recorded for ";
        colors=[["Red","red"],["Green","green"],["Blue","blue"]]; //2nd value is css color name*/
    }


    //window.alert(txtInitFrms);
    document.getElementById("btHdCol").innerHTML=colors[colIdx][0]+txtHds;


    document.getElementById("innHtml").value = document.getElementById("artWelcome").innerHTML;
    document.getElementById("tCont"  ).value = document.getElementById("artWelcome").textContent;

    let allElm=document.querySelectorAll("*");
    for(let i=0;i<allElm.length;i++){
        allElm[i].addEventListener("click",eventEcho);
        allElm[i].addEventListener("focus",eventEcho);
    }

}



function writeInnerHtml(elmId) {
    let elm=document.getElementById(elmId);
    let tArea = document.getElementById("innHtml");
    if(elm !== null && elm !== undefined){
        elm.innerHTML=tArea.value;
        tArea.value=elm.innerHTML;
    }else{
        window.alert(txtWriteAlert)
    }
}

//oproti predchadzajuceho je pouzity iny pristup k prvkom formulara
//this function uses a different way to access form elements than writeInnerHtml
function writeTextContent(elmId) {
    let elm=document.getElementById(elmId);
    let tArea = document.forms[0].elements["tCont"]; //tu moze byt hodnota atributu id alebo name
                                                     //it can use the value of the id or name attribute
    if(elm !== null && elm !== undefined){
        elm.textContent=tArea.value;
        tArea.value=elm.textContent;
    }else{
        window.alert(txtWriteAlert)
    }
}

function addArticle() {
    let newArt = document.createElement("article");

    //element title vytvorim cez createElement a pridam ako posledny (tu jediny) priamy potomok newArt
    //the element title is created using createElement and added as the last (here the only) last child element of newArt
    let title= document.createElement("h2");
    title.innerHTML=document.getElementById("newArtTtl").value;
    newArt.appendChild(title);

    //obsah clanku pridam na koniec HTML obsahu elementu newArt
    //the article content is appended to the HTML content of the newArt element
    newArt.innerHTML +=document.getElementById("newArtCnt").value;

    //novy clanok pridam ako posledny, tzn. pred element hr
    //the article is added after the last one in the document, i.e. before the hr element
    document.body.insertBefore(newArt,document.getElementById("endArts"));

    //clanku pridam id atribut, aktualizujem href odkazu na posledny clanok a zvysim pocitadlo:
    //the id attribute is added to the article, the href attribute of the anchor element linking to the last article is updated and the nextArtIndex counter is incremented.
    newArt.setAttribute("id","cl"+nextArtIndex);
    document.getElementById("lastArt").setAttribute("href","#cl"+nextArtIndex);
    nextArtIndex++;



}

function removeFirst() {
    let elm=document.querySelector("body > article");
    if(elm !== null && elm !== undefined){
        document.body.removeChild(elm);
    }else{
        window.alert(txtNoRemove);

    }
}

function removeLast() {
    let elms=document.querySelectorAll("body > article");
    if(elms.length>0){
        document.body.removeChild(elms[elms.length-1]);
    }else{
        window.alert(txtNoRemove);
    }
}

function changeHeadingColors(){
    let headings=document.querySelectorAll("body > article > h2");
    for(let i=0;i<headings.length;i++){
        headings[i].style.color=colors[colIdx][1];
    }
    colIdx=(colIdx+1)%(colors.length);
    document.getElementById("btHdCol").innerHTML=colors[colIdx][0]+txtHds;
}

function removeListenerEventEcho(eventName){
    let vsetkyElm=document.querySelectorAll("*");
    for(let i=0;i<vsetkyElm.length;i++){
        vsetkyElm[i].removeEventListener(eventName,eventEcho);
    }
}

function eventEcho(event){
    console.log(txtEvent+event.type+txtOn+event.target.tagName+txtRecFor+event.currentTarget.tagName);

}